<?php
/*
 * Plugin Name: Fast ActiveCampaign
 * Plugin URI: https://www.fastflow.io/products/fast-activecampaign
 * Description: ActiveCampaign addon for Fast Flow
 * Version: 1.1.4
 * Author: FastFlow
 * Author URI: https://www.fastflow.io
 */

// get wordpress version number and fill it up to 9 digits

$int_wp_version = preg_replace('#[^0-9]#', '', get_bloginfo('version'));
while(strlen($int_wp_version) < 9) {
    $int_wp_version .= '0';
}
// get php version number and fill it up to 9 digits

$int_php_version = preg_replace('#[^0-9]#', '', phpversion());
while(strlen($int_php_version) < 9) {
    $int_php_version .= '0';
}

if ($int_wp_version >= 390000000 && 		// Wordpress version > 3.9
    $int_php_version >= 520000000 && 		// PHP version > 5.2
    defined('ABSPATH') && 			// Plugin is not loaded directly
    defined('WPINC')) {				// Plugin is not loaded directly
        define('FAST_AC_DIR', dirname(__FILE__));
        define('FAST_AC_URL', plugins_url('/', __FILE__));
        add_filter('ff_settings', 'fast_AC_settings_html', 5, 1 );
        add_filter('ff_settings_data', 'fast_flow_process_AC_data', 5, 1);
        add_filter('FM_AR_select_options_addons', 'fast_AC_AR_select_options', 21, 2 );
        add_filter('FM_AR_options_HTML_addons', 'fast_AC_AR_options_HTML', 21, 2 );
        add_action('FM_add_to_AR_addons', 'fast_AC_add_to_AR', 21, 2 );
        add_action('admin_notices', 'active_campaign_admin_notice__error');
        add_action('FF_add_to_AR_addons', 'fast_AC_add_FF_user_to_AR', 21, 2 );


    } else add_action('admin_notices', 'fast_activecampaign_incomp');

function fast_activecampaign_incomp(){
    echo '<div id="message" class="error">
    <p><b>The &quot;Fast ActiveCampaign&quot; Plugin does not work on this WordPress installation!</b></p>
    <p>Please check your WordPress installation for following minimum requirements:</p>
    <p>
    - WordPress version 3.9 or higer<br />
    - PHP version 5.2 or higher<br />
    </p>
    <p>Do you need help? Contact <a href="mailto:support@fastflow.io">Support</a></p>
    </div>';
}

//add_action('FM_after_member_registered', 'list_tagged_user_in_ac', 30, 3);
/*function list_tagged_user_in_ac($fm_member_id, $prodid = 0, $userid = 0)
{
	$option_name ='pro_tags_'.$prodid;
	$option_value = get_option( $option_name , true);
	//var_dump($option_value);
	//exit;
	$terms = array();
	if(is_array($option_value)){
		$tags = array_map('intval',$option_value);
		foreach($tags as $tag_id){
			$terms[] = get_term($tag_id);
		}
	}
	//var_dump($fm_member_id);echo "<br/>";
	//var_dump($prodid);echo "<br/>";
	//var_dump($userid);echo "<br/>";
	//exit;
    	//Add tags (Product tags) to user
	$option_name ='pro_tags_'.$prodid;
	$option_value = get_option( $option_name , true);
	if(is_array($option_value) && !empty($option_value)){
		$tags = array_map('intval',$option_value);
		wp_set_object_terms($userid, $tags, 'fast_tag', true);
	}
}*/
function fastflow_get_settings_db($for='') {

    if( !empty( $for ) && $for !== '' ) {

        global $wpdb;

        $data = $wpdb->get_results( $wpdb->prepare( "SELECT * FROM {$wpdb->prefix}fastflow_settings
                                        WHERE settings_for=%s", $for ) );

        if( count($data) >= 1 ) {
            return $data[0];
        } else return false;
    }
    return false;
}

function fast_flow_process_AC_data($data) {
  global $wpdb;
  $data_arr = array();
  $data_arr['fmacapiurl'] = empty( $_POST['fmacapiurl'] ) ? '' : sanitize_text_field( $_POST['fmacapiurl'] );
  $data_arr['fmacapikey'] = empty( $_POST['fmacapikey'] ) ? '' : sanitize_text_field( $_POST['fmacapikey'] );
  $data_arr['listid'] = empty( $_POST['listid'] ) ? '' : sanitize_text_field( $_POST['listid'] );
  //$data_arr['switch'] = empty( $_POST['switch'] ) ? '' : sanitize_text_field( $_POST['switch'] );
  $data_ser = serialize($data_arr);
  $count = $wpdb->get_var( "SELECT COUNT(ID) FROM {$wpdb->prefix}fastflow_settings
                                                                      WHERE settings_for='Active Campaign'" );

    if( $count == 1 ) {
        $wpdb->update(
            $wpdb->prefix . 'fastflow_settings',
            array( 'settings_data' => $data_ser, 'extra_data' => '' ),
            array( 'settings_for' => 'Active Campaign' ),
            array( '%s', '%s' ),
            array( '%s' )
          );
    } else {
        $wpdb->insert(
            $wpdb->prefix . 'fastflow_settings',
            array( 'settings_for' => 'Active Campaign', 'settings_data' => $data_ser, 'extra_data' => '' ),
            array( '%s', '%s', '%s' ) );
    }
    return $data;
}
function fast_AC_settings_html( $html){
	//global $wpdb;
	    //$obj = $wpdb->get_results("SELECT settings_data FROM {$wpdb->prefix}fastflow_settings WHERE settings_for = 'Active Campaign'");
//print "<pre>";
//error_log("Here are Details:".print_r($obj[0],true));
//print "</pre>";
//exit;
	//$fmxtraoptions = unserialize($obj[0]->settings_data);
	//print_r($fmxtraoptions);
	//exit;
  $settings_heading = 'Active Campaign';
  $ac_db = fastflow_get_settings_db('Active Campaign');
  $ac_options = empty( $ac_db->settings_data ) ? array() : unserialize( $ac_db->settings_data );
  $fastflow_acapiurl = empty( $ac_options['fmacapiurl'] ) ? '' : $ac_options['fmacapiurl'];
  $fastflow_acapikey = empty( $ac_options['fmacapikey'] ) ? '' : $ac_options['fmacapikey'];
  if(function_exists('is_fac_active') && is_fac_active()){
    $fastflow_listid = empty( $ac_options['listid'] ) ? '' : $ac_options['listid'];
    //$fastflow_switch = ($ac_options['switch'] == 1 ) ? "checked='checked'" : '';
    $ac = fast_AC_api_ready();
    if($ac){
      $all_lists = $ac->api( 'list/list', array( 'ids' => 'all' ) );
      $list_arr = json_decode( json_encode( $all_lists ), true );

      $options = '<option value="">Select Default List</option>';
      foreach($list_arr as $list){
      //print "<pre>";print_r($list);print "</pre>";exit;
        if(is_array($list)){
          $selected = ($fastflow_listid == $list['id'])?"selected='selected'":"";
          $options .= '<option '.$selected.' value="'.$list["id"].'" >'.$list["name"].'</option>';
        }
      }
    }
  }
      $settings_html = '<h1><strong>Active Campaign</strong></h1>';
      $settings_html .= '<div class="item-tab-box">';
          $settings_html .= '<table cellspacing="10" width="100%">
                                              <tr><td width="30%">'.__("API URL").':</td><td width="70%"><input type="text" id="fmacapiurl" style="width: 390px;" name="fmacapiurl" value="' . $fastflow_acapiurl . '" /></td></tr>
                                              <tr><td width="30%">'.__("API key").':</td><td width="70%"><input type="text" id="fmacapikey" style="width: 390px;" name="fmacapikey" value="' . $fastflow_acapikey . '" /></td></tr>
                                              <tr><td width="30%">'.__("Webhook URL").':</td><td width="70%"><input type="text"  style="width: 390px;" value="' .plugins_url('fast-activecampaign/fac-webhook.php'). '" disabled/></td></tr>';
    if(function_exists('is_fac_active') && is_fac_active()){
			$settings_html .='
												<tr><td width="100%" colspan="2">'.__("<strong>Fast Tags Global Settings</stong>").'</td></tr>
												<!--tr><td width="30%">'.__("Fast Tags Integration").':</td><td width="70%"><input '.$fastflow_switch.' type="checkbox" id="switch" style="" name="switch" value="1" /></td></tr-->
												<tr><td width="30%">'.__("Default List Id").':</td><td width="70%"><select id="listid" style="" name="listid">'.$options.'</select></td></tr>';
		}
      $settings_html .=' </table>';
      $settings_html .= '</div>';
    return $html.$settings_html;
}

function fast_AC_AR_select_options( $value, $selected_opts ){
    $selected_attr = ( $selected_opts == 8 ) ? "selected='selected'" : "";
    $fsn_opts = "<option value='8'{$selected_attr}>Active Campaign</option>";
    $return_val = $fsn_opts . $value;
    return $return_val;
}

function fast_AC_api_ready() {
    global $wpdb;
    $sttopt_obj = $wpdb->get_results("SELECT fmxtraoptions FROM {$wpdb->prefix}wpbn_settings WHERE 1");
    $obj = $wpdb->get_results("SELECT settings_data FROM {$wpdb->prefix}fastflow_settings WHERE settings_for = 'Active Campaign'");
	//var_dump($sttopt_obj);
	if($obj){
		//settings coming from FF Plugins settings page
		$fmxtraoptions = unserialize($obj[0]->settings_data);
        $api_url = $fmxtraoptions['fmacapiurl'];
        $api_key = $fmxtraoptions['fmacapikey'];
        require_once( FAST_AC_DIR . "/includes/ac-api/ActiveCampaign.class.php" );
        $ac = new ActiveCampaign($api_url, $api_key);
	}else
    {
        require_once( FAST_AC_DIR . "/includes/ac-api/ActiveCampaign.class.php" );
        $api_url = '';
        $api_key = '';
        $ac = new ActiveCampaign($api_url, $api_key);
    }

	/* settings coming from FM plugin settings page
    if( count($sttopt_obj)>0 ) {
        $sttoptserial = $sttopt_obj[0]->fmxtraoptions;
        $fmxtraoptions = unserialize($sttoptserial);
        $api_url = $fmxtraoptions['fmacapiurl'];
        $api_key = $fmxtraoptions['fmacapikey'];
        require_once( FAST_AC_DIR . "/includes/ac-api/ActiveCampaign.class.php" );
        $ac = new ActiveCampaign($api_url, $api_key);
    }
	*/
    if (!(int)$ac->credentials_test()) {
        return false;
    } else {
        return $ac;
    }
}

function fast_AC_AR_options_HTML( $value, $selected_opts ){
    $acdisp = ( $selected_opts == 8 ) ? "block" : "none";
    $set_val = sanitize_text_field($_POST['fmaclistid']);
    $set_val2 = sanitize_text_field($_POST['fmacformid']);
    $fmac_tags = sanitize_text_field($_POST['fmactags']);
    $sel_html = "<input type='text' id='fmaclistid' style='width: 200px;' name='fmaclistid' value='" . $set_val . "' />";
    $sel_html2 = "<input type='text' id='fmacformid' style='width: 200px;' name='fmacformid' value='" . $set_val2 . "' />";
    $ac = fast_AC_api_ready();
    if( $ac !== false ) {
        $all_lists = $ac->api( 'list/list', array( 'ids' => 'all' ) );
        $list_arr = json_decode( json_encode( $all_lists ), true );
        $sel_html = "<select name='fmaclistid' id='fmaclistid' ><option value=''>[select list]</option>";
        foreach ( $list_arr as $key => $val ) {
            if ( is_numeric($key) ) {
                $sel_html .= sprintf( "<option value='{$val['id']}'%s>$val[name]</option>", ( $val['id'] == $set_val ) ? ' selected' : '' );
            }
        }
        $sel_html .= "</select>";
        $all_forms = $ac->api( 'form/getforms' );
        $form_arr = json_decode( json_encode( $all_forms ), true );
        $sel_html2 = "<select name='fmacformid' id='fmacformid'><option value=''>[select form]</option>";
        foreach ( $form_arr as $key => $val ) {
            if ( is_numeric($key) ) {
                $sel_html2 .= sprintf( "<option value='{$val['id']}'%s>$val[name]</option>", ( $val['id'] == $set_val2 ) ? ' selected' : '' );
            }
        }
        $sel_html2 .= "</select>";
    }
    $return_html = $value . "<div style='display:$acdisp' id='arbox8' class='arcontentbox'>"
                    . "<table cellspacing='10'>"
                        . "<tr><td style='width: 140px;'>Mailing List ID:</td><td>" . $sel_html . "</td></tr>"
                        . "<tr><td style='width: 140px;'>Subscription Form ID:</td><td>" . $sel_html2 . "</td></tr>"
                        . "<tr><td>Tags:</td><td><input type='text' id='fmactags' style='width: 200px;' name='fmactags' value='" . $fmac_tags . "' /></td></tr>"
                    . "</table></div>";
    return $return_html;
}

function fast_AC_add_to_AR( $userid, $prodid ){
    global $wpdb;
    $pdata = $wpdb->get_results($wpdb->prepare("SELECT * FROM {$wpdb->prefix}wpbn_products WHERE id=%d",$prodid));
    $arservice = $pdata[0]->arservice;
    error_log("Inside AC api, arservice: {$arservice}");
    if( $arservice != 8 ) { return; }
    $aroptions = unserialize($pdata[0]->aroptions);
    $ac_list_id = $aroptions['fmaclistid'];
    $ac_tags = $aroptions['fmactags'];
    $ac_form_id = $aroptions['fmacformid'];
    $email = get_userdata($userid)->user_email;
    $first_name = get_user_meta($userid, 'first_name', true);
    $last_name = get_user_meta($userid, 'last_name', true);
    if( empty( $first_name ) ) $first_name = "first_name";
    if( empty( $last_name ) ) $last_name = "";
    $ac = fast_AC_api_ready();
    $loggvar = "<pre>" . print_r($ac, true) . "</pre>";
    error_log("AC api ready:\n{$loggvar}");
    if( $ac !== false ) {
        $contact = array(
            "email"                 => $email,
            "first_name"            => $first_name,
            "last_name"             => $last_name,
            "p[{$ac_list_id}]"      => $ac_list_id,
            "tags"                  => $ac_tags,
            "form"                  => $ac_form_id,
            "status[{$ac_list_id}]" => 1, // "Active" status
	);
        $loggvar2 = "<pre>" . print_r($contact, true) . "</pre>";
        error_log("AC contact:\n{$loggvar2}");
        $contact_sync = $ac->api("contact/sync", $contact);
        $loggvar3 = "<pre>" . print_r($contact_sync, true) . "</pre>";
        error_log("AC contact sync:\n{$loggvar3}");
    }
}

function active_campaign_admin_notice__error() {
		if( is_plugin_active( 'fast-activecampaign/fast-activecampaign.php' ) ) {
			$class = 'notice notice-error';
			$message = 'Please input API keys for <a href="'.admin_url("admin.php?page=fast-flow-settings").'">Active Campaign.</a>';
	    $ac = fast_AC_api_ready();
			if($ac){
				return true;
			}else{
				printf( '<div class="%1$s is-dismissible"><p>%2$s</p></div>', esc_attr( $class ), ($message) );
			}
		}else{
			return true;
		}
	}

  function fast_AC_add_FF_user_to_AR($data, $form_id){
    global $wpdb;
    $fast_form = get_post($form_id);
    if($fast_form->post_type == 'fast-forms'){
      $arservice = get_post_meta( $fast_form->ID, 'ff_auto_reponder', true );
      if( $arservice != 8 ) { return; }
      $ac_list_id = get_post_meta( $fast_form->ID, 'fmaclistid', true );
      $ac_tags = get_post_meta( $fast_form->ID, 'fmactags', true );
      $ac_form_id = get_post_meta( $fast_form->ID, 'fmacformid', true );
      if(empty($ac_list_id)){
        error_log( "Empty AC FF List ID" );
        return;
      }
      $email = trim($data['email']);
      $first_name = trim( $data['name'] );
      $last_name = '';
      unset($data['name']);
      unset($data['email']);
      if ( empty( $first_name ) || $first_name == "" ){ $first_name = $email;}
      $ac = fast_AC_api_ready();
      $loggvar = "<pre>" . print_r($ac, true) . "</pre>";
      error_log("AC FF api ready:\n{$loggvar}");
      if( $ac !== false ) {
          $contact = array(
              "email"                 => $email,
              "first_name"            => $first_name,
              "last_name"             => $last_name,
              "p[{$ac_list_id}]"      => $ac_list_id,
              "tags"                  => $ac_tags,
              "form"                  => $ac_form_id,
              "status[{$ac_list_id}]" => 1, // "Active" status
              "field[%UUID%, 0]" => $data['fastuid'],
              "field[%UTM_MEDIUM%, 0]" => $data['utm_medium'],
              "field[%UTM_CAMPAIGN%, 0]" => $data['utm_campaign'],
              "field[%UTMSOURCE%, 0]" => $data['utm_source']
            );
          $loggvar2 = "<pre>" . print_r($contact, true) . "</pre>";
          error_log("AC FF contact:\n{$loggvar2}");
          $contact_sync = $ac->api("contact/sync", $contact);
          $loggvar3 = "<pre>" . print_r($contact_sync, true) . "</pre>";
          error_log("AC FF contact sync:\n{$loggvar3}");
      }

    }
  }
